;1. najveci zajednicki delilac brojeva x i y
(defun nzd (x y)
     (cond ((equal x y) x)
           (t (prog (a)
           (cond ((< x y) (setq a y) (setq y x) (setq x a)))
                          (return (nzd y (- x y))))) 
     ) 
)


;2. za listu (a1 a2 ... an) daje listu (fa1 ... fan) gde fa1 je f(a1) i sl.
(defun mmapcar1(f x)
      (prog(y z)
           (setq y x)
           (setq z nil)
      opet
           (cond 
                ((null y) (return (reverse z)))
                (t (setq z (cons (apply f(list (car y))) z)))
           )
           (setq y (cdr y))
           (go opet)
      )
)


; 3. definicijafunkcije fold
(defun fold (fun init l)
    (cond 
        ((null l) init)
        (t (fun (car l) (fold fun init (cdr l))))
    )
)

; proizvod elemenata liste
(defun proizvod(L) (fold mnozi 1 L))

;definicija funkije koja mnozi dva broja
(defun mnozi (x y) (* x y))


;4. zbir dve liste
(defun zbir_pom (l1 l2)
    (cond
        ((null l1) l2)
        ((null l2) l1)
        (t (append (list (+ (car l1) (car l2))) (zbir_pom (cdr l1) (cdr l2))))
    )
)

; zbir polinoma
(defun zbir (p q)
   (list (zbir_pom (car p) (car q)) (zbir_pom (cadr p) (cadr q)))) 


;5. spajanje dve sortirane liste
(defun merge(l1 l2)
   (cond 
      ((null l1) l2)
      ((null l2) l1)
      ((< (car l1) (car l2)) (append (list (car l1)) (merge (cdr l1) l2)))
      (t (append (list (car l2)) (merge l1 (cdr l2))))
   )
) 

; minimalni element liste
(defun minimum (l)
    (prog (m q)
       (setq m (car l))
       (setq q l)
  loop
       (setq q (cdr q))
       (cond 
          ((null q) (return m))
          ((< (car q) m) (setq m (car q)) (go loop))       
          (t (go loop))
       )
    )
)

; sortiranje liste       
(defun sort (l)
     (cond 
        ((null l) nil)
        (t (setq m (minimum l)) (append (list m) (sort (izbaci m l))))
     )
)

; izbacuje se iz liste l prvo pojavljivanje elementa el
(defun izbaci (el l)
     (cond
          ((null l) nil)
          ((equal el (car l)) (cdr l))
          (t (cons (car l) (izbaci el (cdr l))))
     )
)

; sortirana unija dve liste
(defun merge-sort (l1 l2)
     (merge (sort l1) (sort l2)))


;6. obrat liste x
(defmacro obrat(x)        
      `(prog(y z)
           (setq y ,x)
           (setq z nil)
      opet
           (cond 
                ((null y) (return z))
           )
           (setq z (cons (car y) z))
           (setq y (cdr y))
           (go opet)
      )
)
